<?php
//add setting page to menu

function wra_rest_api_settings_page_content()
{

	global $wpdb;
	$query = "SELECT * FROM {$wpdb->base_prefix}wra_queue where status=0";
	$totalitems = $wpdb->query($query);
	if ($totalitems)
		echo '<div class="notice notice-warning is-dismissible"><p>
			شما ' . $totalitems . ' درخواست در صف ارسال دارید. <a href="admin.php?page=rest_api_queues">مشاهده</a>
		</p></div>';
	?>
	<link rel='stylesheet' href='<?php echo plugin_dir_url(__FILE__) ?>../assets/style.css'>
	<div class="wrap">
		<h1>تنظیمات</h1>
		<form method="post" action="options.php">
			<?php
			settings_fields('list_blog_settings');
			do_settings_sections('list_blog');
			submit_button();
			?>
		</form>
	</div>
	<?php
}

// setting page
add_action('admin_init', 'wra_rest_settings_fields');
function wra_rest_settings_fields()
{
	$page_slug = 'list_blog';
	$option_group = 'list_blog_settings';

	// 1. create section
	add_settings_section(
		'rest_section_id',
		'',
		'',
		$page_slug
	);

	// 2. add fields
	register_setting($option_group, 'wra_state', 'string');

	add_settings_field(
		'wra_state',
		'وب سرویس فعال باشد',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_state'
		)
	);

	register_setting($option_group, 'wra_ip', 'string');
	add_settings_field(
		'wra_ip',
		'IP',
		'wra_form_input',
		$page_slug,
		'rest_section_id',
		array(
			'label_for' => 'wra_ip',
			'class' => 'hello',
			'name' => 'wra_ip'
		)
	);

	register_setting($option_group, 'wra_port', 'string');
	add_settings_field(
		'wra_port',
		'PORT',
		'wra_form_input',
		$page_slug,
		'rest_section_id',
		array(
			'label_for' => 'wra_port',
			'class' => 'hello',
			'name' => 'wra_port'
		)
	);


	add_settings_field(
		'text1',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'اطلاعات IP و PORT جهت اتصال به سرور نرم افزار حسابداری است. (IP static)<br>
			معمولا سرورها پورت هایی به غیر از 80، 8080، 443 و 25 را مسدود می کنند (ترجیحا از پورت های 80 یا 443 استفاده نمایید).
			'
		)
	);

	register_setting($option_group, 'wra_api_key', 'string');
	add_settings_field(
		'wra_api_key',
		'API KEY',
		'wra_form_input',
		$page_slug,
		'rest_section_id',
		array(
			'label_for' => 'wra_api_key',
			'class' => 'hello',
			'name' => 'wra_api_key'
		)
	);

	add_settings_field(
		'text2',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'کلید تبادل دریافتی از نرم افزار حسابداری'
		)
	);


	// register_setting($option_group, 'wra_time', 'string');
	// register_setting($option_group, 'wra_day', 'string');
	// register_setting($option_group, 'wra_hours', 'string');
	// register_setting($option_group, 'wra_hour', 'string');
	// register_setting($option_group, 'wra_minute', 'string');
	// add_settings_field(
	// 	'wra_period',
	// 	'بازه همگام سازی اطلاعات',
	// 	'wra_form_period',
	// 	$page_slug,
	// 	'rest_section_id',
	// 	array(
	// 		'label_for' => 'wra_period',
	// 		'class' => 'hello',
	// 		'name' => 'wra_period'
	// 	)
	// );




	add_settings_field(
		'button',
		'',
		'wra_form_buttons',
		$page_slug,
		'rest_section_id',
		array(
			'link' => '?page=rest_api_settings&wra_update=1',
			'class' => '',
			'name' => 'button',
			'text' => 'همگام سازی آنی'
		)
	);

	if (intval(get_option('wra_total_products')) > 0) {
		add_settings_field(
			'update_text',
			'آخرین کالاهای دریافت شده',
			'wra_form_html',
			$page_slug,
			'rest_section_id',
			array(
				'text' => get_option('wra_from_product') . ' تا ' . get_option('wra_to_product') . ' از ' . get_option('wra_total_products') . ' کالا'
			)
		);
	}



	register_setting($option_group, 'wra_updates', 'string');
	add_settings_field(
		'wra_updates',
		'تعداد بروزرسانی در هر لحظه',
		'wra_form_input',
		$page_slug,
		'rest_section_id',
		array(
			'label_for' => 'wra_updates',
			'class' => 'hello',
			'name' => 'wra_updates',
			'text' => 'عدد'

		)
	);


	add_settings_field(
		'text3',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'مشخص می نماید در هر درخواست چه تعداد محصول بروزرسانی شوند. (با توجه به قدرت سرور سایت این گزینه را انتخاب نمایید)'
		)
	);

	//register_setting($option_group, 'wra_priceInWC', 'string');
	add_settings_field(
		'wra_priceInWC',
		'قیمت ها در ووکامرس',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => '<p class="pt-1">'.
			(get_option('woocommerce_currency') == 'IRT' ? 'تومان' : '').
			(get_option('woocommerce_currency') == 'IRR' ? 'ریال' : '').
			((get_option('woocommerce_currency') != 'IRR' && get_option('woocommerce_currency') != 'IRT')  ? '<span style="color:red;">'.__(get_option('woocommerce_currency')). '<br>لطفا واحد پولی را به ریال یا تومان تغییر دهید.</span>' : '').
			'</p> <br><a class="button button-primary" href="?page=wc-settings">تغییر واحد پولی</a>'
		)      
	);


	// add_settings_field(
	// 	'wra_priceInWC',
	// 	'قیمت ها در ووکامرس',
	// 	'wra_form_select',
	// 	$page_slug,
	// 	'rest_section_id',
	// 	array(
	// 		'label_for' => 'wra_priceInWC',
	// 		'class' => 'hello',
	// 		'name' => 'wra_priceInWC',
	// 		'options' => ['ریال', 'تومان']

	// 	)
	// );

	register_setting($option_group, 'wra_priceInApp', 'string');
	add_settings_field(
		'wra_priceInApp',
		'قیمت ها در نرم افزار',
		'wra_form_select',
		$page_slug,
		'rest_section_id',
		array(
			'label_for' => 'wra_priceInApp',
			'class' => 'hello',
			'name' => 'wra_priceInApp',
			'options' => ['ریال', 'تومان']

		)
	);

	register_setting($option_group, 'wra_send_factor', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_send_factor',
		'ارسال فاکتور به نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_send_factor'
		)
	);

	add_settings_field(
		'text4',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'فاکتورهای موفق در ووکامرس در نرم افزار حسابداری ایجاد شود یا خیر'
		)
	);



	register_setting($option_group, 'wra_get_title', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_get_title',
		'دریافت نام کالا از نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_get_title'
		)
	);
	add_settings_field(
		'text8',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که وب سرویس نرم افزار در دسترس باشد، در زمان افزودن کالا به سبد خرید، موجودی کالا از نرم افزار استعلام می شود و موجودی کالا در نرم افزار معیار قرار داده می شود. (موجودی کالا در وب سایت در این لحظه با موجودی کالا در نرم افزار یکسان می شود)	'
		)
	);




	register_setting($option_group, 'wra_get_stock', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_get_stock',
		'دریافت موجودی کالا از نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_get_stock'
		)
	);
	add_settings_field(
		'text13',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که وب سرویس نرم افزار در دسترس باشد، در زمان افزودن کالا به سبد خرید، نام کالا از نرم افزار استعلام می شود و نام کالا در نرم افزار معیار قرار داده می شود. (نام کالا در وب سایت در این لحظه با نام کالا در نرم افزار یکسان می شود)	'
		)
	);


	

	register_setting($option_group, 'wra_update_images', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_update_images',
		'اعمال تصاویر کالاهای سایت براساس نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_update_images'
		)
	);
	add_settings_field(
		'text9',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که این گزینه را انتخاب کرده باشید، تصویر شاخص کالا با تصویر ارسالی از نرم افزار جایگزین می شود و در صورتی که مایل باشید کالا تصاویر بیشتری داشته باشد، بایستی کالا را در وب سایت ویرایش کنید و تصاویر مد نظر را به گالری تصاویر هر کالا بیافزایید.'
		)
	);


	register_setting($option_group, 'wra_update_price', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_update_price',
		'اعمال قیمت های سایت براساس قیمت کالاهای نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_update_price'
		)
	);
	add_settings_field(
		'text11',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که این گزینه را انتخاب کرده باشید، قیمت کالاها در وب سایت و نرم افزار دقیقا مطابق با یکدیگر خواهد بود. توجه نمایید، در صورتی که کالاهای شما دارای خصوصیت باشد و قیمت های کالاها بر مبنای خصوصیت اعمال می گردد، این گزینه را فعال ننمایید. (چون در نرم افزار نمی توانید بر مبنای خصوصیت قیمت را اعمال کنید)'
		)
	);



	register_setting($option_group, 'wra_update_discount', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_update_discount',
		'اعمال تخفیفات سایت براساس تخفیفات کالاهای نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_update_discount'
		)
	);
	add_settings_field(
		'text10',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که این گزینه را انتخاب کرده باشید، تخفیفات کالاها در وب سایت و نرم افزار دقیقا مطابق با یکدیگر خواهد بود. توجه نمایید، در صورتی که کالاهای شما دارای خصوصیت باشد و قیمت های کالاها بر مبنای خصوصیت اعمال می گردد، این گزینه را فعال ننمایید. (چون در نرم افزار نمی توانید بر مبنای خصوصیت قیمت را اعمال کنید)'
		)
	);




	register_setting($option_group, 'wra_update_description', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_update_description',
		'اعمال توضیحات سایت براساس توضیحات کالاهای نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_update_description'
		)
	);
	add_settings_field(
		'text12',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که این گزینه را انتخاب کرده باشید، توضیحات کالاها در وب سایت و نرم افزار دقیقا مطابق با یکدیگر خواهد بود.'
		)
	);




	register_setting($option_group, 'wra_save_action_logs', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_save_action_logs',
		'ثبت گزارش پردازش اطلاعات دریافتی از نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_save_action_logs'
		)
	);

	add_settings_field(
		'text42',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که این گزینه را انتخاب کرده باشید، گزارش پردازش محصولات، گروه ها و ... ثبت خواهد شد.'
		)
	);




	register_setting($option_group, 'wra_IsInsertPersonInfo', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_IsInsertPersonInfo',
		'ثبت شخص در نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_IsInsertPersonInfo'
		)
	);
 
	add_settings_field(
		'text43',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که این گزینه را انتخاب کرده باشید، شخص فاکتور در وب سایت، در نرم افزار ثبت می شود.'
		)
	);


	register_setting($option_group, 'wra_IsUpdatePersonInfo', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_IsUpdatePersonInfo',
		'ویرایش شخص در نرم افزار',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_IsUpdatePersonInfo'
		)
	); 


	add_settings_field(
		'text44',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'در صورتی که این گزینه را انتخاب کرده باشید، اطلاعات شخص فاکتور در وب سایت، در نرم افزار ویرایش می شود.'
		)
	);





	register_setting($option_group, 'wra_developer_mode', 'wra_rest_sanitize_checkbox');
	add_settings_field(
		'wra_developer_mode',
		'حالت توسعه دهنده',
		'wra_form_chkbox',
		$page_slug,
		'rest_section_id',
		array(
			'name' => 'wra_developer_mode'
		)

	);

	add_settings_field(
		'text5',
		'',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => 'جهت ثبت و مشاهده لاگ های عملکرد وب سرویس، این گزینه را فعال نمایید'
		)
	);


	$connection = get_option('wra_connect');
	$connection_text = '';
	switch ($connection) {
		case 0:
			$connection_text = '<span style="color:black;font-weight: bold;">تا بحال ارتباط برقرار نشده است</span>';
			break;
		case 1:
			$connection_text = '<span style="color:green;font-weight: bold;">ارتباط با موفقیت برقرار شد</span>';
			break;
		case -2:
			$connection_text = '<span style="color:red;font-weight: bold;">عدم ارتباط با وب سرویس</span>';
			break;
		case -1:
			$connection_text = '<span style="color:#ff8b00;font-weight: bold;">ارتباط با وب سرویس برقرار شد (ارتباط با دیتابیس برقرار نیست)</span>';
			break;
		default:
			$connection_text = '<span style="color:black;font-weight: bold;">تا بحال ارتباط برقرار نشده است</span>';
			break;
	}
	$connection_text .= ' <button type="button" class="button button-primary" style="font-size: 12px;padding-bottom: 2px;margin-top: -5px;margin-right: 7px;" id="check-connection" onclick="window.location=\'?page=rest_api_settings&check-connection\'">بررسی مجدد</button>';

	add_settings_field(
		'text6',
		'وضعیت اتصال به نرم افزار حسابداری',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => $connection_text
		)
	);

	$sock = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
	$res = socket_connect($sock, '8.8.8.8', 53);
	// You might want error checking code here based on the value of $res
	socket_getsockname($sock, $addr);
	socket_shutdown($sock);
	socket_close($sock);

	if ($addr) {
		add_settings_field(
			'text7',
			'IP جهت درج در نرم افزار',
			'wra_form_html',
			$page_slug,
			'rest_section_id',
			array(
				'text' => '<b>' . $addr . '</b>'
			)
		);
	} else {
		add_settings_field(
			'text7',
			'IP جهت درج در نرم افزار',
			'wra_form_html',
			$page_slug,
			'rest_section_id',
			array(
				'text' => '<b>جهت دریافت IP با مدیریت هاست خود در ارتباط باشید.</b>'
			)
		);
	}


	// add_settings_field(
	// 	'text7',
	// 	'IP جهت درج در نرم افزار',
	// 	'wra_form_html',
	// 	$page_slug,
	// 	'api_ip_log',
	// 	array(
	// 		'text' => $addr
	// 	)
	// );


	global $wp_version;
	if ($wp_version) {
		add_settings_field(
			'text141',
			'نسخه ووکامرس ',
			'wra_form_html',
			$page_slug,
			'rest_section_id',
			array(
				'text' => '<b>' . $wp_version . '</b>'
			)
		);
	}






	add_settings_field(
		'text140',
		'نسخه api ',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => '<b>1.23.0</b>'
		)
	);


	add_settings_field(
		'text142',
		'فعالسازی cron job',
		'wra_form_html',
		$page_slug,
		'rest_section_id',
		array(
			'text' => '
			برای تعریف cron job وارد کنترل پنل هاست خود شود و از قسمت cron job دستور زیر را وارد نمایید:
			<br><br>
			CPanel:
			<br>
			<div class="wra-code-view"><b>curl -s ' . get_site_url() . '/wp-admin/admin.php?wra_cron_job=1</b></div>
			<br>
			Direct Admin:<br>
			<div class="wra-code-view"><b>/usr/bin/wget -q -O /dev/null "' . get_site_url() . '/wp-admin/admin.php?wra_cron_job=1" >/dev/null 2>&1</b></div>
			<br>
			Plesk:<br>
			وارد قسمت Scheduled Tasks شوید و روی Add Task کلیک کنید سپس Fetch a URL  را انتخاب و مقدار url را وارد کنید:
			<br>
			<div class="wra-code-view"><b>' . get_site_url() . '/wp-admin/admin.php?wra_cron_job=1
			'
		)
	);




}



if (isset($_GET['settings-updated']) && isset($_GET['page']) && $_GET['page'] == 'rest_api_settings') {
	wra_check_connection();
	wra_connect(1);
	wra_notice(" تنظیمات با موفقیت ذخیره شد.", 'success');
}

if (isset($_GET['check-connection'])) {
	wra_check_connection();
}
